//Il padre legge un vettore da tastiera, quindi crea 2 figli F1 e F2.
// Il padre passa i numeri positivi a F1 e i negativi a F2.
// F1 calcola la media dei numeri positivi e la ritorna al padre che
// la stampa. F2 crea un nipote N, gli passa i numeri positivi e Nip
// calcola il minimo dei numeri negativi e lo ritorna a F2 che lo ritorna al padre che lo stampa.
#include <sys/types.h> 
#include <unistd.h> 
#include <stdio.h>
#include <stdlib.h>

void Figlio1(int pd[]);
void Figlio2(int pd[]);
#define N 10

int main()
{
int vet[]={1,2,3,4,5,-1,-2,-3,-4,-5};
int pid, status, nfiglio,i;
int pdF1[2],pdF2[2], pdNip[2];
int tappo;
int min_neg;
double med_pos;

if (pipe (pdF1)==-1)
	{printf ("Errore pipe\n");exit(1);}
if (pipe(pdF2)==-1)
	{printf ("Errore pipe\n");exit(1);}
nfiglio=1;
pid=fork();  //creo F1
if (pid>0)
	{nfiglio=2; pid=fork();}    // creo F2
switch (pid)
{
case -1: printf("Errore nella fork\n"); exit(2); break;
case 0:  if (nfiglio==1)
		Figlio1(pdF1);
	else
		Figlio2(pdF2);
	break;
default:   // codice padre
	   for  (i=0;i<N;i++)
		if (vet[i]>0)
			write(pdF1[1],&vet[i],sizeof(int));
		else if (vet[i]<0)
			write(pdF2[1],&vet[i],sizeof(int));
	   	tappo=0;
		write (pdF1[1],&tappo, sizeof(int));			
		write (pdF2[1],&tappo, sizeof(int));			
		// aspetto i 2 figli
		wait(&status);	
		wait(&status);
		read(pdF1[0],&med_pos,sizeof(double));
		read(pdF2[0],&min_neg,sizeof(int));
		printf("Media positivi %.2f\n",med_pos);
		printf("Minimo neg. %d\n",min_neg);
		

		
} // fine switch





return 0;
}

void Figlio1(int pd[])
{
// calcola la media dei numeri positivi
double media;
int somma=0, cont=0, letto;

	read (pd[0],&letto,sizeof(int));
	while (letto!=0){
		somma+=letto; cont++;
		read (pd[0],&letto,sizeof(int));
	}  //fine while
	if (cont==0)
		media=0.0;
	else
		media=(double) somma/cont;
	write(pd[1],&media,sizeof(double));
}

void Figlio2(int pd[])
{
// legge i numeri dal padre, manda i numeri al nipote che calcola il minimo
int tappo, min,letto,pidNip;
int pdNip[2]; int status; 

	pipe(pdNip);
	pidNip=fork();
	if (pidNip>0)
	{	// padre del nipote, cioè F2
		read (pd[0], &letto,sizeof(int));
		while (letto!=0){
			write (pdNip[1],&letto,sizeof(int));
			read (pd[0], &letto,sizeof(int));		
		}// fine while
		write (pdNip[1],&tappo,sizeof(int));
		wait (&status);
		read (pdNip[0],&min,sizeof(int));
		write (pd[1],&min,sizeof(int));
	}// fine F2
	else if (pidNip==0)
	{	//codice nipote
		read (pdNip[0],&letto,sizeof(int));
		min=letto;
		while (letto!=0)
		{
			read (pdNip[0],&letto,sizeof(int));
			if (letto<min)
				min=letto;
		} //fine while
		write (pdNip[1],&min,sizeof(int));
		exit (0);

	}//fine nipote
}
